

		.equ	CLK_FREQ, 100000000	; 100 MHz


		.text

; The entry point is the 'main' symbol ... the address 0x00 is occupied by the
; bootstrap
main:
		call	udelay
		call	complex_func
		call	func_string
		jump	main

;
; Function to create some delay ...
; (to demonstate the local label and expression evaluation
;  features)
udelay:
1:
		load	s1, CLK_FREQ / 4000000
2:
		sub	s1, 1
		jump	nz, 2b
		sub	s0, 1
		jump	nz, 1b

		return

;
; Complex function
; (to demonstrate how to implement a 'stack' easily, lets say we
;  have a calling convention that says s4-s15 must be preserved and
;  that this function touches s0->s7 ...)
;
complex_func:
		store	s4, (sp)0
		store	s5, (sp)1
		store	s6, (sp)2
		store	s7, (sp)3
		add	sp, 4
	
		; Some complex code that changes a lot of registers ...

		sub	sp, 4
		fetch	s7, (sp)3
		fetch	s6, (sp)2
		fetch	s5, (sp)1
		fetch	s4, (sp)0

		return


;
; Example of initialized data
;

; This is read only and should not be modified
		.rodata
str1:		.asciz		"Hello"


; This is read/write data zone but initialized at each boot.
; (so the bootstrap keeps a pristine copy in the rodata section and
;  overwrites the data section with this copy at each boot)
		.data
value:		.byte		0xaa, 0xbb, 0xcc, 0xdd


; This zone is cleared at each boot by the bootstrap
		.bss
tempstr:	.space 16

		.text


func_string:
		load	s0, str1
		load	s1, tempstr
		call	strcpy		; Could be optimized with jump strcpy ...
		return
	

strcpy:
		fetch	s2, (s0)
		compare	s2, 0x00
		return	z
		store	s2, (s1)
		add	s0, 1
		add	s1, 1
		jump	strcpy

